import type {DDBReadOnlyClientConfiguration} from '../DDBReadOnlyClient.ts'

export const formatKey = <Item extends object, PKName extends keyof Item, SKName extends keyof Item | never = never>(
  config: DDBReadOnlyClientConfiguration<Item, PKName, SKName>,
  partitionKey: Item[PKName],
  sortKey?: Item[SKName] | string,
) => {
  return config.sortKeyName
    ? `(${String(config.partitionKeyName)}: '${partitionKey}', ${String(config.sortKeyName)}: '${sortKey}')`
    : `(${String(config.partitionKeyName)}: '${partitionKey}')`
}
