import type {AttributeValue} from '@aws-sdk/client-dynamodb'
import {marshall} from '@aws-sdk/util-dynamodb'
import type {DDBReadOnlyClientConfiguration} from '../DDBReadOnlyClient.ts'

export const mapKey = <Item extends object, PKName extends keyof Item, SKName extends keyof Item | never = never>(
  config: DDBReadOnlyClientConfiguration<Item, PKName, SKName>,
  partitionKey: Item[PKName],
  sortKey?: Item[SKName],
): {[key: string]: AttributeValue} => {
  return config.sortKeyName && sortKey
    ? marshall(
        {
          [config.partitionKeyName]: partitionKey,
          [config.sortKeyName]: sortKey,
        },
        {removeUndefinedValues: true},
      )
    : marshall(
        {
          [config.partitionKeyName]: partitionKey,
        },
        {removeUndefinedValues: true},
      )
}
