import {spawnSync} from 'child_process'

export const startDDBContainer = async (containerName = 'dynamodb-local') => {
  const {status} = spawnSync(`docker`, `run --name ${containerName} -d -p 8000:8000 amazon/dynamodb-local`.split(' '), {
    stdio: 'inherit',
  })
  if (status ?? 1 > 0) process.exit(status)

  let remainingTries = 50
  while (remainingTries--) {
    const httpCode = spawnSync(`curl`, `-s -o /dev/null -I -w %{http_code} http://localhost:8000`.split(' '), {
      stdio: 'pipe',
    }).stdout.toString()
    if (httpCode !== '000') break

    await new Promise((resolve) => setTimeout(resolve, 100))
  }
}
